#ifndef __DDS_C
#define __DDS_C

#define B28       (1<<13)
#define HLB       (1<<12)
#define FSEL      (1<<11)
#define PSEL      (1<<10)
#define PIN_SW    (1<<9)
#define RESET     (1<<8)
#define SLEEP1	  (1<<7)
#define SLEEP12   (1<<6)
#define OPBITEN	  (1<<5)
#define SIGN_PIB  (1<<4)
#define DIV2   	  (1<<3)
#define MODE	  (1<<1)

#define SET_SCLK  GPIOB->BSRR = GPIO_BSRR_BS4
#define CLR_SCLK  GPIOB->BSRR = GPIO_BSRR_BR4

#define SET_SDATA GPIOB->BSRR = GPIO_BSRR_BS5
#define CLR_SDATA GPIOB->BSRR = GPIO_BSRR_BR5

#define SET_FSYNC GPIOB->BSRR = GPIO_BSRR_BS3
#define CLR_FSYNC GPIOB->BSRR = GPIO_BSRR_BR3

#define SET_RESET GPIOB->BSRR = GPIO_BSRR_BS6
#define CLR_RESET GPIOB->BSRR = GPIO_BSRR_BR6

#define delay     __no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation();__no_operation()


void DDS_init (void);
void send_SPI (u16 data);
void set_DDS_freq (void);


void DDS_init (void){
u16 temp = 0;  
  
  temp = (B28 | RESET);                         //Reset
  send_SPI(temp);
  
  set_DDS_freq();                       //Set FREQ
  temp = 0xC000;                        //Set PHASE
  send_SPI(temp);                        
  

  temp = 0;                             //Exit from RESET, START DDS
  temp = (B28 | SLEEP12 | OPBITEN | DIV2);
  send_SPI(temp);
}


void send_SPI (u16 data){
s8 i;
  
   SET_FSYNC;     delay;delay;          
   SET_SCLK;      delay;delay;    
   CLR_FSYNC;     delay;delay;
              
   
   for (i=0;i<16;i++){
     (data & 0x8000) ? (SET_SDATA) : (CLR_SDATA);   delay;delay;      
     CLR_SCLK;    delay;delay;      
     data <<= 1;
     SET_SCLK;    delay;delay; 
              
   }
   
   SET_FSYNC;     delay;delay;
}


void set_DDS_freq (void){

  //10011100110101111011100100
double temp;
double DDS_clk = DDS_CLK;
double DDS_resolution = 268435456;
u16 LSB_out;
u16 MSB_out;
  
   temp = (DDS_OUT_FREQ * DDS_resolution) / DDS_clk;        // FreqReg = Fout * 2^28 / DDS_clk
   //temp = (28122040 * DDS_resolution) / DDS_clk;
   //temp = (2000000 * DDS_resolution) / DDS_clk;
   
   LSB_out = (u32)temp;
   LSB_out = (LSB_out & (~0xC000)) | (1<<14); //Clear 2 MSB and set bit 14
   
   MSB_out = ((u32)temp >> 14);
   MSB_out = (MSB_out & (~0xC000)) | (1<<14); //Clear 2 MSB and set bit 14
   
   send_SPI(LSB_out);
   send_SPI(MSB_out);
    
}




#endif /* __DDS_C */