#ifndef __PSK_C
#define __PSK_C
#include "varicode2.h"


char IN_char;
u8 TX_enable = 1; 
u8 TX_ready = 1; 
u8 curr_bit = 0;

u16 PSK_routine (void);

u16 PSK_routine (void) {
static u16 varicode_char = 0;                   //     
static u16 curr_phase;
static s16 cos_table_index = 0;
static s8 direction = 0;
u16 out;

  //    ASCII  
  if (TX_enable){                                 //   
    if (TX_ready && IN_char) {                    //     
       TX_ready = 0;                              //     
       varicode_char = varicode_table[IN_char];   //     
       varicode_char <<= 3;                       //      
       curr_bit = 15; while (!(varicode_char & (1<<curr_bit))) curr_bit--; //   
       curr_phase = 0;
    }
  } 
  
  //    VARICODE
  if (varicode_char & (1<<curr_bit)) {           
    out = cos_table_10[cos_table_index];
  }
  else {
    if (curr_phase == 0) (cos_table_index == 0) ? (direction = 1) : (direction = -1);
    cos_table_index += direction;
    if (cos_table_index > 1023) cos_table_index = 1023;
    if (cos_table_index < 0) cos_table_index = 0;
    out = cos_table_10[cos_table_index];
  }
  
  //   
  curr_phase = (++curr_phase) & 0x3FF;
  if (curr_phase == 0) curr_bit--;                //  1024 ,   
  if (curr_bit == 0) {                            //  ,     
    TX_ready = 1;
    varicode_char = 0;
  }
return out;
}




//   ASCII   PSK.
void putPSK (char in_ascii){
  IN_char = in_ascii;	                      //    
  while (TX_ready);		              //      
  while (!TX_ready);	                      //   
  IN_char = 0;
}



#endif /* __DDS_C */