                                          //    
#define  HCE_20MHZ
//#define  HCE_8MHZ
                                          //   DDS
//#define  DDS_CLK       80000000
#define  DDS_CLK       20000000
                                          //   DDS
#define  DDS_OUT_FREQ  1838000


#include "stm32f10x.h"
#include "CosTable_10.h"
#include "DDS.c"
#include "psk.c"
#include "write.c"
#include "stdio.h"
#include "mpl115a1.c"


#define MIX_ENABLE    GPIOB->BSRR = GPIO_BSRR_BR12
#define MIX_DISABLE   GPIOB->BSRR = GPIO_BSRR_BS12
#define Button1       GPIO_IDR_IDR13
#define Button2       GPIO_IDR_IDR14
#define Button3       GPIO_IDR_IDR15

#define LED1_blink    GPIOB->ODR ^= GPIO_ODR_ODR2
#define LED2_blink    GPIOB->ODR ^= GPIO_ODR_ODR10
#define LED3_blink    GPIOB->ODR ^= GPIO_ODR_ODR11


void InitAll( void);
void Delay( unsigned int Val);

int main( void) {

  InitAll();
  DDS_init ();

  while( 1) { 
     //printf("vvvvv RA9MGK/RB Standalone QRPP beacon without computer. Only three chip." 
     //"PWR 0,5 Wt QTH MO64QX97 E-mail: ra9mgk@yandex.ru 73!\r");
    
     //printf("vvv RA9MGK/RB Standalone QRPP beacon without computer. Only three chip." 
     //"Supercompact antenna (0,6 m). PWR 0,5 Wt QTH MO65RA58 E-mail: ra9mgk@yandex.ru." 
     //"More info: ra9mgk.narod.ru/beacon 73!\r");     
    
     printf("vvv RA9MGK/RB Standalone QRPP beacon without computer. Only three chip." 
     " Antenna - triangle with perimeter 160 m. PWR 0,5 Wt QTH MO65PB70" 
     " E-mail: ra9mgk@yandex.ru. More info: ra9mgk.narod.ru/beacon 73!\r");        
  }
}



//     2
void TIM2_IRQHandler(void) {
u16 temp;
 
  temp = PSK_routine();
  DAC->DHR12R1 = 2047 + temp;
  DAC->DHR12R2 = 2047 - temp;

  TIM2->SR &= ~TIM_SR_UIF;                 //Clear CC1 interrupt flag
  NVIC_ClearPendingIRQ(TIM2_IRQn);         //     
}

//     3
void TIM3_IRQHandler(void) {
  LED1_blink;
  (GPIOB->IDR & Button1) ? (MIX_ENABLE) : (MIX_DISABLE);
  TIM3->SR &= ~TIM_SR_UIF;                 //Clear CC1 interrupt flag
  NVIC_ClearPendingIRQ(TIM3_IRQn);         //     
}
 
//------------------------------------------------------------------------------
 
void InitAll( void) {
   //---   PLL   ---------------------------------------------------------------
   RCC->CR |= RCC_CR_HSEON;                //   HSE.
   while (!(RCC->CR & RCC_CR_HSERDY)) {};  //   HSE.
#ifdef HCE_8MHZ
    RCC->CFGR |= RCC_CFGR_PLLMULL6;         // 0100: PLL input clock x 6
    RCC->CR|=RCC_CR_PLLON;                  // PLL.
    while (!(RCC->CR & RCC_CR_PLLRDY)) {};  //   PLL.
    RCC->CFGR &=~RCC_CFGR_SW;               //   SW0, SW1.
    RCC->CFGR |= RCC_CFGR_SW_PLL;           //  PLL   
#endif
#ifdef HCE_20MHZ    
   RCC->CFGR |= RCC_CFGR_SW_HSE;         //  HSE   
#endif   
   //RCC->CFGR |= RCC_CFGR_MCO;            //  MCO  1/2   PLL
   RCC->CFGR |= RCC_CFGR_MCO_HSE;          //  MCO  HCE
  
  //---   GPIO   ---------------------------------------------------------------
  //      PORTA
  RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;               // Enable PORTA Periph clock  
  GPIOA->CRH &= ~(GPIO_CRH_MODE8 | GPIO_CRH_CNF8);  // Clear PA.8 control register bits
  GPIOA->CRH |= (GPIO_CRH_MODE8 | GPIO_CRH_CNF8_1); // Configure PA.8 as Push Pull output at max 50Mhz
  //   DAC1 PA.4
  GPIOA->CRL &= ~(GPIO_CRL_MODE4 | GPIO_CRL_CNF4);  // Clear PA.4 control register bits
  GPIOA->CRL |= (GPIO_CRL_MODE4_1 | GPIO_CRL_CNF4_0 | GPIO_CRL_CNF4_1); // Configure PA.4 as Push Pull output at max 2Mhz
  //   DAC2 PA.5
  GPIOA->CRL &= ~(GPIO_CRL_MODE5 | GPIO_CRL_CNF5);  // Clear PA.5 control register bits
  GPIOA->CRL |= (GPIO_CRL_MODE5_1 | GPIO_CRL_CNF5_0 | GPIO_CRL_CNF5_1); // Configure PA.5 as Push Pull output at max 2Mhz
  
  
  //      PORTB 
  //   LED1 PB.2
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;               // Enable PORTB Periph clock  
  GPIOB->CRL &= ~(GPIO_CRL_MODE2 | GPIO_CRL_CNF2);  // Clear PB.2 control register bits
  GPIOB->CRL |= GPIO_CRL_MODE2_0;                   // Configure PB.2 as Push Pull output at max 10Mhz
  //   LED2 PB.10
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;               // Enable PORTB Periph clock  
  GPIOB->CRH &= ~(GPIO_CRH_MODE10 | GPIO_CRH_CNF10);// Clear PB.10 control register bits
  GPIOB->CRH |= GPIO_CRH_MODE10_0;                  // Configure PB.10 as Push Pull output at max 10Mhz
  GPIOB->BSRR = GPIO_BSRR_BS10;
  //   LED3 PB.11
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;               // Enable PORTB Periph clock  
  GPIOB->CRH &= ~(GPIO_CRH_MODE11 | GPIO_CRH_CNF11);// Clear PB.11 control register bits
  GPIOB->CRH |= GPIO_CRH_MODE11_0;                  // Configure PB.11 as Push Pull output at max 10Mhz
  GPIOB->BSRR = GPIO_BSRR_BS11;
  //   DDS RESET
  GPIOB->CRL &= ~(GPIO_CRL_MODE6 | GPIO_CRL_CNF6);  // Clear PB.6 control register bits
  GPIOB->CRL |= GPIO_CRL_MODE6_0;     
  GPIOB->BSRR = GPIO_BSRR_BR6;
  //   FCLK
  GPIOB->CRL &= ~(GPIO_CRL_MODE4 | GPIO_CRL_CNF4);  // Clear PB.4 control register bits
  GPIOB->CRL |= GPIO_CRL_MODE4_0;                   // Configure PB.4 as Push Pull output at max 10Mhz
  GPIOB->BSRR = GPIO_BSRR_BS4;
  //   FSYNC
  GPIOB->CRL &= ~(GPIO_CRL_MODE3 | GPIO_CRL_CNF3);  // Clear PB.3 control register bits
  GPIOB->CRL |= GPIO_CRL_MODE3_0;   
  GPIOB->BSRR = GPIO_BSRR_BS3;
  //   SDATA
  GPIOB->CRL &= ~(GPIO_CRL_MODE5 | GPIO_CRL_CNF5);  // Clear PB.5 control register bits
  GPIOB->CRL |= GPIO_CRL_MODE5_0;                   // Configure PB.5 as Push Pull output at max 10Mhz
  
  
  //   ENABLE MIXER PB.12 Active LOW
  GPIOB->CRH &= ~(GPIO_CRH_MODE12 | GPIO_CRH_CNF12); // Clear PB.12 control register bits
  GPIOB->CRH |= GPIO_CRH_MODE12_0;                   // Configure PB.12 as Push Pull output at max 10Mhz
  GPIOB->BSRR = GPIO_BSRR_BR12;
  //   Button 1
  GPIOB->CRH &= ~(GPIO_CRH_MODE13 | GPIO_CRH_CNF13); // Clear PB.13 control register bits
  GPIOB->CRH |= GPIO_CRH_CNF13_1;                    // Configure PB.13 as Input with pull-up / pull-down
  GPIOB->ODR |= GPIO_ODR_ODR13;                      // Set pull-up
  //   Button 2
  GPIOB->CRH &= ~(GPIO_CRH_MODE14 | GPIO_CRH_CNF14); // Clear PB.14 control register bits
  GPIOB->CRH |= GPIO_CRH_CNF14_1;                    // Configure PB.14 as Input with pull-up / pull-down
  GPIOB->ODR |= GPIO_ODR_ODR14;                      // Set pull-up
  //   Button 3
  GPIOB->CRH &= ~(GPIO_CRH_MODE15 | GPIO_CRH_CNF15); // Clear PB.15 control register bits
  GPIOB->CRH |= GPIO_CRH_CNF15_1;                    // Configure PB.15 as Input with pull-up / pull-down
  GPIOB->ODR |= GPIO_ODR_ODR15;                      // Set pull-up
  
  
  //   MPL115A1
  //   MPL SCLK PB.8 
  GPIOB->CRH &= ~(GPIO_CRH_MODE8 | GPIO_CRH_CNF8);// Clear PB.8 control register bits
  GPIOB->CRH |= GPIO_CRH_MODE8_0;                  // Configure PB.8 as Push Pull output at max 10Mhz
  GPIOB->ODR |= GPIO_ODR_ODR8;
  //   MPL DIN PB.9 
  GPIOB->CRH &= ~(GPIO_CRH_MODE9 | GPIO_CRH_CNF9); // Clear PB.9 control register bits
  GPIOB->CRH |= GPIO_CRH_CNF9_1;                    // Configure PB.9 as Input with pull-up / pull-down
  GPIOB->ODR |= GPIO_ODR_ODR9;                      // Set pull-up
  //   MPL SHDN
  GPIOC->CRH &= ~(GPIO_CRH_MODE15 | GPIO_CRH_CNF15);// Clear PC.15 control register bits
  GPIOC->CRH |= GPIO_CRH_MODE15_0;                  // Configure PC.15 as Push Pull output at max 10Mhz
  //GPIOC->ODR |= GPIO_ODR_ODR15;
  //   MPL DOUT
  GPIOC->CRH &= ~(GPIO_CRH_MODE13 | GPIO_CRH_CNF13);// Clear PC.13 control register bits
  GPIOC->CRH |= GPIO_CRH_MODE13_0;                  // Configure PC.13 as Push Pull output at max 10Mhz
  //GPIOC->ODR |= GPIO_ODR_ODR13;
  //   MPL CS
  GPIOC->CRH &= ~(GPIO_CRH_MODE14 | GPIO_CRH_CNF14);// Clear PC.14 control register bits
  GPIOC->CRH |= GPIO_CRH_MODE14_0;                  // Configure PC.14 as Push Pull output at max 10Mhz
  GPIOC->ODR |= GPIO_ODR_ODR14;
  
  
  
  
  // JTAG,   SWD
  RCC->APB2ENR |=RCC_APB2ENR_AFIOEN;
  AFIO->MAPR |= AFIO_MAPR_SWJ_CFG_JTAGDISABLE;
  
  
  //---   DAC   ----------------------------------------------------------------
  
  RCC->APB1ENR |= RCC_APB1ENR_DACEN;                //  
  DAC->CR = 0;
  //DAC->CR |= DAC_CR_BOFF1;                          // DAC channel1 output buffer disabled
  //DAC->CR |= DAC_CR_BOFF2;                          // DAC channel2 output buffer disabled
  DAC->CR |= DAC_CR_EN1;                            // EN1: DAC channel1 enabled
  DAC->CR |= DAC_CR_EN2;                            // EN2: DAC channel2 enabled
  
  DAC->DHR12R1 = 0;
  DAC->DHR12R2 = 4095;
  

  
  //---   UART   ---------------------------------------------------------------
  
  
    
  RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;               //  2
  TIM2->DIER |= TIM_DIER_UIE;                       //   
  //TIM2->PSC = 24-1;                               //   1 
  //TIM2->ARR = 3000;                               // 8     125  (8 kHz),    

#ifdef HCE_8MHZ  
  TIM2->ARR = 750;                                  // 32 kHz at 24MHz MCLK
#endif

#ifdef HCE_20MHZ  
  TIM2->ARR = 625;                                  // 32 kHz at 20MHz MCLK
#endif  
  
  TIM2->CR1 |= TIM_CR1_CEN;                         // 2. 
  
  RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;               //  2
  TIM3->DIER |= TIM_DIER_UIE;                       //   
  TIM3->PSC = 24000-1;                               //   1 
  TIM3->ARR = 200;                                  // 32 kHz at 24MHz MCLK
  TIM3->CR1 |= TIM_CR1_CEN;                         // 2. 
  
  
  NVIC_SetPriority(TIM2_IRQn, 15);
  NVIC_EnableIRQ(TIM2_IRQn);
  NVIC_SetPriority(TIM3_IRQn, 15);
  NVIC_EnableIRQ(TIM3_IRQn);
  //  NVIC_SetPriority(TIM7_IRQn, 15);
  //  NVIC_EnableIRQ(TIM7_IRQn);
  //  NVIC_SetPriority(USART1_IRQn, 15);
  //  NVIC_EnableIRQ(USART1_IRQn);
  //  NVIC_SetPriority(ADC1_IRQn, 15);
  //  NVIC_EnableIRQ(ADC1_IRQn);
  
  __enable_irq();       // Enable Interrupts
  

   return;
}
 
//------------------------------------------------------------------------------
 
void Delay( unsigned int Val) {
  for( ; Val != 0; Val--) {
   __NOP();
  }
}

